---
title: Create Swatch
slug: api-documentation/create-swatch
docTags: 
createdAt: 2026-08-27T16:53:40.115Z
---

{
  "id": "-q-WyivZo2xFDtKJXXHG8",
  "type": "api-oas-v2",
  "data": {
    "method": "POST",
    "url": "https://api.upstartcommerce.com/v1/catalog/swatches",
    "servers": [
      {
        "url": "https://api.upstartcommerce.com/v1/catalog/swatches"
      }
    ],
    "name": "Create Swatch",
    "description": "<p>Creates a new swatch.</p>\n<p>Authorized permissions:</p>\n<ul>\n<li><code>catalog.swatch.create</code></li>\n</ul>",
    "contentType": "application/json",
    "request": {
      "pathParameters": [],
      "headerParameters": [
        {
          "name": "accept",
          "type": "string",
          "kind": "optional",
          "description": "Generated from available response content types",
          "enum": [
            "application/json"
          ],
          "default": "application/json"
        },
        {
          "kind": "required",
          "name": "x-upstart-tenant",
          "type": "string",
          "description": "Tenant identifier associated with the site this call is for."
        },
        {
          "kind": "optional",
          "name": "x-upstart-site",
          "type": "string",
          "description": "Unique identifier for the site."
        }
      ],
      "queryParameters": [],
      "bodyDataParameters": [
        {
          "kind": "required",
          "name": "body",
          "type": "object",
          "description": "<p>This defines the structure, used to create a swatch.</p>",
          "customType": "CreateSwatch",
          "schema": [
            {
              "name": "id",
              "kind": "optional",
              "type": "string",
              "description": "",
              "modelRef": "#/components/schemas/SwatchIdType",
              "customType": "SwatchIdType",
              "schema": []
            },
            {
              "name": "name",
              "kind": "required",
              "type": "string",
              "description": ""
            },
            {
              "name": "imageUrl",
              "kind": "optional",
              "type": "string",
              "description": "",
              "pattern": "^(http:\\/\\/www\\.|https:\\/\\/www\\.|http:\\/\\/|https:\\/\\/)?[a-z0-9]+([\\-\\.]{1}[a-z0-9]+)*\\.[a-z]{2,5}(:[0-9]{1,5})?(\\/.*)?$"
            },
            {
              "name": "imageAltText",
              "kind": "optional",
              "type": "string",
              "description": ""
            },
            {
              "name": "description",
              "kind": "optional",
              "type": "string",
              "description": ""
            },
            {
              "name": "tags",
              "kind": "optional",
              "type": "array",
              "description": "",
              "example": "",
              "itemType": "string",
              "customType": "string[]",
              "itemExample": "",
              "itemDefault": ""
            },
            {
              "name": "collection",
              "kind": "required",
              "type": "string",
              "description": "",
              "modelRef": "#/components/schemas/SwatchCollectionId",
              "customType": "SwatchCollectionId",
              "schema": []
            },
            {
              "name": "vendor",
              "kind": "optional",
              "type": "string",
              "description": ""
            },
            {
              "name": "hexCode",
              "kind": "optional",
              "type": "string",
              "description": "",
              "pattern": "^#[0-9a-fA-F]{6}$"
            }
          ],
          "modelRef": "#/components/schemas/CreateSwatch",
          "isExpanded": true
        }
      ],
      "formDataParameters": [],
      "oAuthParameters": [
        {
          "id": "NoChannelPortalAccess",
          "name": "NoChannelPortalAccess",
          "kind": "optional",
          "type": "http",
          "description": "<p>This authentication is required for clients to interact with any of the management APIs. Similar to \"LoggedIn\", it indicates that the user has actually logged into the system, but in this case with a management role.</p>",
          "scheme": "bearer"
        }
      ],
      "cookieParameters": []
    },
    "responses": [
      {
        "statusCode": "201",
        "description": "Newly created swatch",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "This defines the swatch structure.",
            "customType": "Swatch",
            "schema": [
              {
                "name": "id",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "name",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "imageUrl",
                "kind": "optional",
                "type": "string",
                "description": "",
                "pattern": "^(http:\\/\\/www\\.|https:\\/\\/www\\.|http:\\/\\/|https:\\/\\/)?[a-z0-9]+([\\-\\.]{1}[a-z0-9]+)*\\.[a-z]{2,5}(:[0-9]{1,5})?(\\/.*)?$"
              },
              {
                "name": "imageAltText",
                "kind": "optional",
                "type": "string",
                "description": ""
              },
              {
                "name": "description",
                "kind": "optional",
                "type": "string",
                "description": ""
              },
              {
                "name": "tags",
                "kind": "required",
                "type": "array",
                "description": "",
                "example": "",
                "itemType": "string",
                "customType": "string[]",
                "itemExample": "",
                "itemDefault": ""
              },
              {
                "name": "collection",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "vendor",
                "kind": "optional",
                "type": "string",
                "description": ""
              },
              {
                "name": "hexCode",
                "kind": "optional",
                "type": "string",
                "description": "<p>Optional hex color code for the swatch (e.g., \"#FF5733\").</p>",
                "pattern": "^#([A-Fa-f0-9]{6}|[A-Fa-f0-9]{3})$"
              }
            ],
            "modelRef": "#/components/schemas/Swatch",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "400",
        "description": "The request contained information that the server was unable to process. Appropriate errors are provided in the response body.",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "ValidationErrorResponse",
            "schema": [
              {
                "name": "name",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "code",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "detail",
                "kind": "optional",
                "type": "string",
                "description": ""
              }
            ],
            "modelRef": "#/components/schemas/ValidationErrorResponse",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "401",
        "description": "The provided credentials were not valid for this endpoint. It may be that they are expired or that the user's roles are insufficient.",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "ErrorResponse",
            "schema": [
              {
                "name": "name",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "code",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "detail",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "reason",
                "kind": "optional",
                "type": "string",
                "description": ""
              }
            ],
            "modelRef": "#/components/schemas/ErrorResponse",
            "isExpanded": true
          }
        ]
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "_gU1rh_t2oDTuLBk6CMYe",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request POST \\\n     --url https://api.upstartcommerce.com/v1/catalog/swatches \\\n     --header 'accept: application/json' \\\n     --header 'content-type: application/json' \\\n     --header 'x-upstart-tenant: string' \\\n     --data '{\n     \"name\": \"\",\n     \"collection\": \"\"\n     }'"
        },
        {
          "id": "pvUF3wYpxqkBow9ErTRnq",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\nmyHeaders.append(\"x-upstart-tenant\", \"string\");\n\nvar raw = JSON.stringify({\n   \"name\": \"\",\n   \"collection\": \"\"\n});\n\nvar requestOptions = {\n   method: 'POST',\n   headers: myHeaders,\n   body: raw,\n   redirect: 'follow'\n};\n\nfetch(\"https://api.upstartcommerce.com/v1/catalog/swatches\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "LDmhUgXyGzQgH91BZuk9X",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://api.upstartcommerce.com/v1/catalog/swatches\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Post.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\nrequest[\"x-upstart-tenant\"] = \"string\"\nrequest.body = JSON.dump({\n   \"name\": \"\",\n   \"collection\": \"\"\n})\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "qJD0L3Q64JCOBXUZmUP4K",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://api.upstartcommerce.com/v1/catalog/swatches\"\n\npayload = json.dumps({\n   \"name\": \"\",\n   \"collection\": \"\"\n})\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json',\n   'x-upstart-tenant': 'string'\n}\n\nresponse = requests.request(\"POST\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "_gU1rh_t2oDTuLBk6CMYe"
    },
    "results": {
      "languages": [
        {
          "id": "VZZSJaCkVnHHq7-sZkuy9",
          "language": "201",
          "code": "// Newly created swatch\n{\n  \"id\": \"\",\n  \"name\": \"\",\n  \"imageUrl\": \"\",\n  \"imageAltText\": \"\",\n  \"description\": \"\",\n  \"tags\": [\n    \"\"\n  ],\n  \"collection\": \"\",\n  \"vendor\": \"\",\n  \"hexCode\": \"\"\n}"
        },
        {
          "id": "nlU8MSWbF3kAW9OVju4OX",
          "language": "400",
          "code": "// The request contained information that the server was unable to process. Appropriate errors are provided in the response body.\n{\n  \"name\": \"\",\n  \"code\": \"\",\n  \"detail\": \"\"\n}"
        },
        {
          "id": "x0UHPExNwwlCStCbPPDeC",
          "language": "401",
          "code": "// The provided credentials were not valid for this endpoint. It may be that they are expired or that the user's roles are insufficient.\n{\n  \"name\": \"\",\n  \"code\": \"\",\n  \"detail\": \"\",\n  \"reason\": \"\"\n}"
        }
      ],
      "selectedLanguageId": "VZZSJaCkVnHHq7-sZkuy9"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}